local insert = table.insert
local remove = table.remove
--local unpack = table.unpack

-----------------------------------------------------------------------------------
-- - - - - - - - - - - - - - - Global Help Functions - - - - - - - - - - - - - - -- 
-----------------------------------------------------------------------------------

rawset(_G, "getAdjacentPos", function(row, col)
  -- returns table containing all adjacent positions [1]:row [2]:col to given position
  -- INCLUDING SELF. to change this:
  -- add if (not (dx == 0 and dy == 0)) then ... end
  
	local result = {}
	--local str=""
	for dx =-1,1 do
		for dy=-1,1 do
			result[#result+1] = { row+dy, col+dx }
		end  
	end
	/*for i=1,#result do -- Parse results (9)
		str=str.."("..result[i][1]..","..result[i][2]..") "
		if i%3==0 -- Only 3 results per line
			str=str.."\n"
		end
	end
	print(str)*/
	return result
end)

-- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- 

/*rawset(_G, "findNext", function(start, goal)
	-- Finds next step from start position to goal position in a matrix
	if start == goal then return goal end
	local row, col = start[1], start[2]
	local adj = getAdjacentPos(start[1], start[2])
	local dist = getDist(start, goal)
	local nextPos

	for i=1,#adj do
		local adjT = adj[i] -- 3x3 table. #adj = 9
		if (getDist(adjT, goal) < dist)
		and (i%2==0) -- not picking diagonals (would cause too narrow corridors)
		then
			nextPos = adjT
			dist = getDist(nextPos, goal)
			--break           -- uncomment for more rectangular paths!
		end
	end

	-- Debugging
	-- Question: nextPos is nil?
	-- Why the FUCK is it nil? Let's try to find that out...
	if not nextPos
		print("Current (r,c): ("..row..", "..col..")")
		
		local str = ""
		for i=1,#adj do -- Parse num results (9)
			str=str.."("..adj[i][1]..","..adj[i][2]..") "
			if i%3==0 -- Only 3 results per line
				str=str.."\n"
			end
		end
		print(str)
		
		--for k, v in ipairs(adj) -- ALT. Parse 4 directional num results.
		--	if (k%2) continue end
		--	print("("..adj[k][1]..","..adj[k][2]..") ")
		--	if (getDist(adj[k], goal) < dist) 
		--		print(k.." is closest!")
		--	end
		--end
		
		str = ""
		for i=1,#adj do -- Parse true/false results (9)
			local tfv
			if (getDist(adj[i], goal) < dist)-- and (i%2==0)
				tfv = "true"
			else
				tfv = "false"
			end
			
			str=str..tfv..","
			if i%3==0 -- Only 3 results per line
				str=str.."\n"
			end
		end
		print(str+"Whichever one above is true, is the one that WOULD have been our nextPos... BUT...")
	end

	return nextPos
end)*/

-- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- 

rawset(_G, "getRandNeighbour", function(row, col, notDiag)
	if notDiag then 
		local f = {-1, 1}
		local d = f[P_RandomRange(1,2)]
		if P_RandomChance(FRACUNIT/2) then
			return row+d, col
		else
			return row, col+d
		end
	else
		local dir={ P_RandomRange(-1,1), P_RandomRange(-1,1) }
		return row+dir[1], col+dir[2]
	end
end)

-- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- 

/*function withinBounds(r, c, height, width)
  return (r<height and r>0 and c<width and c>0)
end*/

-- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- 

rawset(_G, "prims", function(unvisited)
	local len = #unvisited
	local v0, v1, endIndex
	local root=remove(unvisited, 1)
	if #unvisited==0 then return root, root end

	local visited={}
	insert(visited, root)
	repeat
	local dist = 999    -- ~inf
		for i=1,#visited do
			for j=1,#unvisited do
				if (unvisited[j]:distanceTo(visited[i]) < dist) then
					dist = unvisited[j]:distanceTo(visited[i])
					v0 = visited[i]
					endIndex=j
				end
			end
		end
		v1 = remove(unvisited, endIndex)
		v0:addNeighbour(v1)
		insert(visited, v1)
	until #visited == len

	return visited[1], visited[#visited]
end)

-- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- 

-- source: http://lua-users.org/wiki/CopyTable
-- And since table.unpack doesn't exist with SRB2, just use 'unpack'. ;)
rawset(_G, "clone", function(org)
	return {unpack(org)}
end)

-- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- ##### -- 

-- I'm lazy.
rawset(_G, "getDist", function(start, goal)
	return R_PointToDist2(start[1]*FRACUNIT, start[2]*FRACUNIT, goal[1]*FRACUNIT, goal[2]*FRACUNIT)/FRACUNIT
	--return R_PointToDist2(goal[2]<<FRACBITS, goal[1]<<FRACBITS, start[2]<<FRACBITS, start[1]<<FRACBITS)>>FRACBITS
end)