-----------------------------------------------------------------------------------
-- - - - - - - - - - - - - - - - main - - - - - - - - - - - - - - - - - - - - - - -
-----------------------------------------------------------------------------------

/*rawset(_G, "map", {})

local map.w = 48
local map.h = 48

local map.t = {}
local rooms = {} -- Rooms need paths to connect each other so...
local paths = {} -- We'll need to know where we can put these paths.

map.coords = function(x, y)
	return y*map.w+x
end

map.clear = function()
	for i = 1, (map.w * map.h)
		map.t[i] = 0 -- Everything gets a table entry
	end
	rooms = {}
	paths = {}
end*/

-- Example of generating a dungeon with: 
--  * default settings by using generateDungeon.
addHook("MapLoad", function(mapnum)
	if mapheaderinfo[mapnum].dungeon -- Is this a dungeon?
		-- Settings for level sizes and number of levels in dungeon.
		-- Be mindful to add +1 to your dungeon layouts.
		local height=47
		local width=47
		local nrOfLevels=max(cv_dnglvl.value, 5)

		if not DNG -- No Dungeon Generated yet.
			-- Create Blank Dungeon Object
			DNG = Dungeon:new(nrOfLevels, height, width)

			-- Generate blank dungeon.
			DNG:generateDungeon()

			-- inits a player spawn in each level, a boss in last level
			-- Spawns staircases "Springs" up until the last room.
			-- dungeon:initPlayerSpawn(dungeon.levels[1]) -- For reference
			for i = 1, #DNG.levels
				DNG:initPlayerSpawn(DNG.levels[i])
				
				if i < #DNG.levels
					DNG:initSprings(DNG.levels[i])
					DNG:initKeys(DNG.levels[i])
				end
			end
			DNG:initEnd(DNG.levels[#DNG.levels])
		end
		
		if DNG
			--DNG:printDungeon()
			toSRB2matrix(DNG.levels[DNGLVL])
			-- Begin Dungeon from the current level
			goToLevel(DNG.levels[DNGLVL])
			if not players[0] -- Dedicated netgame
				CONS_Printf(server, "Dungeon Level: "..DNGLVL)
			end
		end
	else
		DNG = 0 -- Null the Dungeon
		DNGLVL=1 -- Back to square 1
		SRB2matrix={} -- Free this up
	end
end)